



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>《Java语言实现快速幂取模》</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">《Java语言实现快速幂取模》</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-16 11:48:21 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>快速幂取模算法的引入是从大数的小数取模的朴素算法的局限性所提出的，在朴素的方法中我们计算一个数比如5^1003%31是非常消耗我们的计算资源的，在整个计算过程中最麻烦的就是我们的5^1003这个过程</p>
<p>缺点1：在我们在之后计算指数的过程中，计算的数字不都拿得增大，非常的占用我们的计算资源（主要是时间，还有空间）</p>
<p>缺点2：我们计算的中间过程数字大的恐怖，我们现有的计算机是没有办法记录这么长的数据的，所以说我们必须要想一个更加高效的方法来解决这个问题</p>
<p>当我们计算AB%C的时候，最便捷的方法就是调用Math函数中的pow方法，但是有时A的B次方数字过大，即使是双精度的double也会溢出，这个时候为了得到AB%C的结果，我们会选择使用快速幂取模算法，简单快速的得到我们想要的结果。</p>
<p>为了防止数字溢出并且降低复杂度，我们需要用到下面的公式:</p>
<p><strong>ab&nbsp;mod c = (a mod c)b&nbsp;mod c</strong></p>
<p>这个公式的意思就是：积的取余等于取余的积的取余。很容易看出来这个公式是具有传递性的，这样我们可以通过不断的取余让a越来越小，防止出现溢出的情况。</p>
<p>理论上，有了这个公式我们就可以写代码了，通过不断的对a进行取模保证结果不会溢出，这确实能计算出较大次方的幂的模，但是这种方法的复杂度仍旧是O(N)，并不快速。</p>
<p>为了更快速的计算出幂的模，我们还要依赖下面这个公式：</p>
<p><strong>ab&nbsp;mod c = (a2)b/2&nbsp;mod c , b为偶数&nbsp;<br />ab&nbsp;mod c = ((a2)b/2&middot;a) mod c , b为奇数</strong></p>
<p>这个公式很简单，原理就是不断的用a的平方来代替b，将b替换为原来的一半。因为我们通过第一个公式知道了一个数的模的相同次方的模相同（这句话说的有点绕，就是公式一的意思）。那么我们用a*a%c的结果来代替a效果是一样的。</p>
<p>所以根据上述的公式，我们得到复杂度O（logN）这样的计算快速幂的方法：</p>
<div>
<div>
<pre class="prettyprint linenums">import java.util.Scanner;

public class Main {

 public static void main(String[] args) {<br />
  Scanner in = new Scanner(System.in);<br />
  int a = in.nextInt(), b = in.nextInt(), c = in.nextInt();<br />
  int res = 1;<br />
  a %= c;<br />
  for (; b != 0; b /= 2) {<br />
   if (b % 2 == 1)<br />
    res = (res * a) % c;<br />
   a = (a * a) % c;<br />
  }<br />
  System.out.println(res);<br />
 }<br />
}</pre>
</div>
<p>案例：</p>
<div>
<div>
<h4>题目描述</h4>
<div>
<p>给定a和b，输出a^b的最后一个数字。</p>
</div>
</div>
</div>
<div>
<div>
<h4>输入格式</h4>
<div>
<p>输入数据有多组，每组数据占一行，每行为a和b的值（0 &lt; = a，b &lt; = 2^30）。</p>
</div>
</div>
</div>
<div>
<div>
<h4>输出格式</h4>
<div>
<p>对每组输入数据，输出a^b的最后一位数字，每组数据占一行。</p>
</div>
</div>
</div>
<div>
<div>
<h4>输入样例&nbsp;复制</h4>
<div>
<pre class="prettyprint linenums"><code>2 2<br />
3 4<br />
</code></pre>
</div>
</div>
</div>
<div>
<div>
<h4>输出样例&nbsp;复制</h4>
<div>
<pre class="prettyprint linenums"><code>4<br />
1</code></pre>
</div>
</div>
</div>
<p>上述的问题就可以用&nbsp; 下面的代码解决 ，思路就是&nbsp; a^b%10 取最后一位</p>
<div>
<pre class="prettyprint linenums">import java.util.Scanner;

public class Main {

    public static void main(String[] args) {<br />
        Scanner cin = new Scanner(System.in);

        while(cin.hasNext()){<br />
            int a = cin.nextInt();<br />
            int b = cin.nextInt();<br />
            if(a&lt;0||b&lt;0){<br />
                return;<br />
            }<br />
            System.out.println(getResult(a, b));

        }

    }

    public static int getResult(int a,int b){<br />
        int res = 1;<br />
        int c = 10;<br />
          a %= c;<br />
          for (; b != 0; b /= 2) {<br />
           if (b % 2 == 1)<br />
            res = (res * a) % c;<br />
           a = (a * a) % c;<br />
          }<br />
          return res;<br />
    }<br />
}</pre>
</div>
</div>
<p>这个算法大概如此，第一步先a%=c是为了将a缩小一些，防止在for中第一次进行a*a的时候数字溢出。在for循环中，如果是b为奇数则令res=res*a，直接先将a乘到结果中去，最后做处理，又是为了防止数字溢出直接将res*a的结果mod c操作。这个for循环中，早晚有一天b会等于1，进入if分支，最后将res的值计算完毕mod c退出for循环，的到最后的结果。</p>
<p>转自:<a href="https://www.jb51.net/article/129333.htm" rel="external nofollow noreferrer">https://www.jb51.net/article/129333.htm</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qy06pd8.html">The Web server is configured to not list the contents of this directory&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kg40j9.html">C&plus;&plus; UFunction&lpar;&lbrace;FLAG&rcub;&rpar; 宏 FLAG 解释笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlzlv18.html">RAID 容量计算器</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdzdo48.html">2-sat按照最小字典序输出可行解（hdu1814）</a>
		</li>
						<li><a href="https://www.batexi.com/a/96o370n9.html">House of hello恶搞包之真假辨别</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdejdd79.html">较好的IOS新闻客户端应用源码</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdlyzk8.html">bzoj 3223&sol;tyvj 1729 文艺平衡树 splay tree</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmdree9.html">关于ios项目沙盒中的文件和Xcode项目创建的文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj7ney9.html">UITableView优化技巧</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vg25n8.html">javascript变量：全局&quest;还是局部？这个得注意！</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w4nx3q.html">linux分区和系统文件和挂载</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmy4px9.html">MyEclipse中jquery文件报错</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkw6gv8.html">【数据库摘要】5&lowbar;Sql&lowbar;IN</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jwdvv8.html">好消息：8月25日广州嵌入式Linux开发免费项目约定你</a>
		</li>
						<li><a href="https://www.batexi.com/a/950o46m8.html">Date Structure01-绪论作业</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kgpk49.html">js函数声明和函数表达式的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gxz56q.html">ROS &ast; 了解xacro的编写</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2evxx9.html">Hibernate&lpar;链接数据库方便得多&rpar;！</a>
		</li>
						<li><a href="https://www.batexi.com/a/90r24rm9.html">Windows Server 2016-WinSer 2016标准版与数据中心版的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2k7v0q.html">json-server基本使用</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qyygv6jq.html">项目中的java文件没有在WEB-INF&bsol;classes中生成class文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gjg36l9.html">CString 成员函数用法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxdyl7z9.html">Spring-Boot构建多模块项目</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gjg4m49.html">python3读文件时报错UnicodeDecodeError&colon; &amp;&num;39&semi;gbk&amp;&num;39&semi; codec can&amp;&num;39&semi;t decode byte 0x9f in position 2&colon; illegal multibyte sequence</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1lnle9.html">自己配置 vue 项目 知识体系&lpar;自己写脚手架 类似 vue-cli &rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qllvn00q.html">UML关系实现、泛化，依赖、组合</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2kz4y9.html">kubernetes组成</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxdyez09.html">ELK之使用heartbeat监控WEB站点</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kj25w39.html">String类，ThreadLocal</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2533doq.html">&lbrack;daily&rsqb;&lbrack;python2&rsqb; int型IP地址与string型IP地址互转</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
